SAABBCollision = Core.class()

function SAABBCollision:init(xtiny, xplayer1, xnmes) -- tiny function
	xtiny.processingSystem(self) -- called once on init and every update
	self.player1 = xplayer1
	self.nmes = xnmes
end

function SAABBCollision:filter(ent) -- tiny function
	return ent.isactor
end

function SAABBCollision:onAdd(ent) -- tiny function
end

function SAABBCollision:onRemove(ent) -- tiny function
end

function SAABBCollision:process(ent, dt) -- tiny function
	for k, v in pairs(self.nmes) do
		if self.player1.y < v.y then -- player1 is behind nme
--			self.player1.spritelayer:addChildAt(self.player1.sprite, 1)
--			self.player1.backlayer:addChild(self.player1.sprite)
			self.player1.backlayer:addChildAt(self.player1.sprite, 1)
			v.spritelayer:addChildAt(v.sprite, 1)
		else -- player1 is in front of nme
--			v.spritelayer:addChildAt(v.sprite, 1)
--			v.backlayer:addChild(v.sprite)
			v.backlayer:addChildAt(v.sprite, 1)
			self.player1.spritelayer:addChildAt(self.player1.sprite, 1)
		end
	end
	local function checkCollision(box1x, box1y, box1w, box1h, box2x, box2y, box2w, box2h)
		if box1x - box1w/2 > box2x + box2w/2 or	-- is box1 on the right side of box2?
		   box1y - box1h/2 > box2y + box2h/2 or	-- is box1 under box2?
		   box1x + box1w/2 < box2x - box2w/2 or	-- is box1 on the left side of box2?
		   box1y + box1h/2 < box2y - box2h/2	-- is box1 above box2?
		then
			return false	-- no collision. Yay!
		else
			return true		-- yes collision. Ouch!
		end
	end
	-- player1 hitbox vs nmes hurtbox
	-- HEAD
	if self.player1.headhitbox and self.player1.headhitbox.isactive then
		for k, v in pairs(self.nmes) do
			if checkCollision(
				self.player1.x+self.player1.headhitbox.x, self.player1.y+self.player1.headhitbox.y,
				self.player1.headhitbox.w, self.player1.headhitbox.h,
				v.x+v.headhurtbox.x, v.y+v.headhurtbox.y,
				v.headhurtbox.w, v.headhurtbox.h) then
				self.player1.spritelayer:addChild(self.player1.sprite) -- change layer order
				if v.washurt <= 0 then
					v.isdirty = true
					v.damage = 3
				end
				self.player1.headhitbox.isactive = false
				-- debug
--				local pixel = Pixel.new(0x0, 0.2, self.player1.headhitbox.w, self.player1.headhitbox.h)
--				pixel:setAnchorPoint(0.5, 0.5)
--				pixel:setPosition(self.player1.x+self.player1.headhitbox.x, self.player1.y+self.player1.headhitbox.y-8)
--				self.player1.spritelayer:addChild(pixel)
			else
				self.player1.headhitbox.isactive = false
				-- debug
--				local pixel = Pixel.new(0xffffff, 0.2, self.player1.headhitbox.w, self.player1.headhitbox.h)
--				pixel:setAnchorPoint(0.5, 0.5)
--				pixel:setPosition(self.player1.x+self.player1.headhitbox.x, self.player1.y+self.player1.headhitbox.y-10)
--				self.player1.spritelayer:addChild(pixel)
			end
		end
	end
	-- SPINE
	if self.player1.spinehitbox and self.player1.spinehitbox.isactive then
		for k, v in pairs(self.nmes) do
			if checkCollision(
				self.player1.x+self.player1.spinehitbox.x, self.player1.y+self.player1.spinehitbox.y,
				self.player1.spinehitbox.w, self.player1.spinehitbox.h,
				v.x+v.spinehurtbox.x, v.y+v.spinehurtbox.y,
				v.spinehurtbox.w, v.spinehurtbox.h) then
--				print("player1 hit nme spine", dt)
				self.player1.spritelayer:addChild(self.player1.sprite) -- change layer order
				if v.washurt <= 0 then
					v.isdirty = true
					v.damage = 1
				end
				self.player1.spinehitbox.isactive = false
				-- debug
--				local pixel = Pixel.new(0x0, 0.2, self.player1.spinehitbox.w, self.player1.spinehitbox.h)
--				pixel:setAnchorPoint(0.5, 0.5)
--				pixel:setPosition(self.player1.x+self.player1.spinehitbox.x, self.player1.y+self.player1.spinehitbox.y-8)
--				self.player1.spritelayer:addChild(pixel)
			else
				self.player1.spinehitbox.isactive = false
				-- debug
--				local pixel = Pixel.new(0xffffff, 0.2, self.player1.spinehitbox.w, self.player1.spinehitbox.h)
--				pixel:setAnchorPoint(0.5, 0.5)
--				pixel:setPosition(self.player1.x+self.player1.spinehitbox.x, self.player1.y+self.player1.spinehitbox.y-10)
--				self.player1.spritelayer:addChild(pixel)
			end
		end
	end
	-- nme hitbox vs player1 hurtbox
	if not ent.isplayer1 then
		-- HEAD
		if ent.headhitbox and ent.headhitbox.isactive then
			if checkCollision(
				ent.x+ent.headhitbox.x, ent.y+ent.headhitbox.y,
				ent.headhitbox.w, ent.headhitbox.h,
				self.player1.x+(self.player1.headhurtbox.x*self.player1.flip), self.player1.y+self.player1.headhurtbox.y,
				self.player1.headhurtbox.w, self.player1.headhurtbox.h) then
				ent.spritelayer:addChild(ent.sprite) -- change layer order
				self.player1.isdirty = true
				ent.headhitbox.isactive = false
				-- debug
--				local pixel = Pixel.new(0x0, 0.9, ent.headhitbox.w, ent.headhitbox.h)
--				pixel:setAnchorPoint(0.5, 0.5)
--				pixel:setPosition(ent.x+ent.headhitbox.x, ent.y+ent.headhitbox.y)
--				ent.spritelayer:addChild(pixel)
			else
				ent.headhitbox.isactive = false
				-- debug
--				local pixel = Pixel.new(0xffffff, 0.1, ent.headhitbox.w, ent.headhitbox.h)
--				pixel:setAnchorPoint(0.5, 0.5)
--				pixel:setPosition(ent.x+ent.headhitbox.x, ent.y+ent.headhitbox.y)
--				ent.spritelayer:addChild(pixel)
			end
		end
		-- SPINE
		if ent.spinehitbox and ent.spinehitbox.isactive then
			if checkCollision(
				ent.x+ent.spinehitbox.x, ent.y+ent.spinehitbox.y,
				ent.spinehitbox.w, ent.spinehitbox.h,
				self.player1.x+(self.player1.spinehurtbox.x*self.player1.flip), self.player1.y+self.player1.spinehurtbox.y,
				self.player1.spinehurtbox.w, self.player1.spinehurtbox.h) then
--				print("nme hit player1 spine", dt)
				ent.spritelayer:addChild(ent.sprite) -- change layer order
				self.player1.isdirty = true
				ent.spinehitbox.isactive = false
				-- debug
--				local pixel = Pixel.new(0x0, 0.9, ent.spinehitbox.w, ent.spinehitbox.h)
--				pixel:setAnchorPoint(0.5, 0.5)
--				pixel:setPosition(ent.x+ent.spinehitbox.x, ent.y+ent.spinehitbox.y)
--				ent.spritelayer:addChild(pixel)
			else
				ent.spinehitbox.isactive = false
				-- debug
--				local pixel = Pixel.new(0xffffff, 0.1, ent.spinehitbox.w, ent.spinehitbox.h)
--				pixel:setAnchorPoint(0.5, 0.5)
--				pixel:setPosition(ent.x+ent.spinehitbox.x, ent.y+ent.spinehitbox.y)
--				ent.spritelayer:addChild(pixel)
			end
		end
	end
end
