SPlayer1 = Core.class()

function SPlayer1:init(xtiny) -- tiny function
	self.tiny = xtiny -- ref so we can remove entities from tiny system
	self.tiny.processingSystem(self) -- called once on init and every update
	-- sfx
	self.snd = Sound.new("audio/sfx/sfx_deathscream_human14.wav")
	self.channel = self.snd:play(0, false, true)
end

function SPlayer1:filter(ent) -- tiny function
	return ent.isplayer1
end

function SPlayer1:onAdd(ent) -- tiny function
end

function SPlayer1:onRemove(ent) -- tiny function
end

function SPlayer1:process(ent, dt) -- tiny function
	if ent.isdirty and ent.currlives > 0 then -- hit
		local function map(v, minSrc, maxSrc, minDst, maxDst, clampValue)
			local newV = (v - minSrc) / (maxSrc - minSrc) * (maxDst - minDst) + minDst
			return not clampValue and newV or clamp(newV, minDst >< maxDst, minDst <> maxDst)
		end
		self.channel = self.snd:play()
		if self.channel then self.channel:setVolume(0.5) end
		ent.hitfx:setVisible(true)
		ent.hitfx:setPosition(ent.x+ent.headhurtbox.x, ent.y+ent.headhurtbox.y)
		ent.spritelayer:addChild(ent.hitfx)
		ent.currhealth -= 1
		if ent.currlives > 0 then
			local hudhealthwidth = map(ent.currhealth, 0, ent.totalhealth, 0, 100)
			self.tiny.hudhealth:setWidth(hudhealthwidth)
			if ent.currhealth == 1 then self.tiny.hudhealth:setColor(0xff0000)
--			elseif ent.currhealth == 2 then self.cworld.hudhealth:setColor(0xff5500)
			end
		end
		ent.washurt = 30 -- timer for a flash effect
		ent.sprite:setColorTransform(2, 0, 0, 3) -- the flash effect (a bright red color)
		ent.isdirty = false
		if ent.currhealth <= 0 then
			ent.currlives -= 1
			self.tiny.hudlives[ent.currlives + 1]:setVisible(false)
--			self.tiny.tworld:removeEntity(ent) -- sprite is removed in SDrawable
--			ent = nil
--			table.remove(self.nmes, i)
			if ent.currlives > 0 then
--				print("YOU DEAD!", dt)
				ent.currhealth = ent.totalhealth
				local hudhealthwidth = map(ent.currhealth, 0, ent.totalhealth, 0, 100)
				self.tiny.hudhealth:setWidth(hudhealthwidth)
				self.tiny.hudhealth:setColor(0x00ff00)
				if ent.currlives == 1 then self.tiny.hudlives[1]:setColor(0xff0000) end
			end
		end
	end
	if ent.currlives <= 0 then -- deaded
		ent.animation.curranim = g_ANIM_LOSE1_R
--		self.tiny.losescreen:setPosition(ent.x + 30, ent.y + 24)
--		self.tiny.losescreen:setVisible(true)
		ent.sprite:setColorTransform(255*2/255, 255/255, 255/255, 1)
		ent.animation.bmp:setY(ent.animation.bmp:getY()-1)
		if ent.animation.bmp:getY() < -200 then
			scenemanager:changeScene("levelX", 1, transitions[math.random(#transitions)], easings[math.random(#easings)])
		end
	end
end





